var env = require('./env'),
	core = require('./core');

module.exports = { evaluate: evaluate };

function evaluate(_, global){
//	try {
		if (core.stringp(_)){
			try {
				if (_.indexOf('.') > -1){
					var paths = _.split('.'),
						root = env.eget(global, paths[0]),
						value = root;
					for (var n = 1, l = paths.length; n < l; n++)
						value = value[paths[n]];
					value.__root = root;
					return value;
				}
				return env.eget(global, _);
			} catch(e) {
				return _;
			}
		} else if (core.hashp(_)){
			var keys = env.keys(_),
				values = env.values(_).map(function(v){ 
					return evaluate(v, global);
				});
			return env.mkhash(keys,values);
		} else if (!core.arrayp(_)){
			return _;
		} else if (_.length == 0){
			return [];
		} else {
			switch (_[0]){
				case 'quote':
					return _[1];
				case 'hash':
					var value = evaluate(_[1], global),
						hash = {};
					value.map(function(kov,i){
						if (i % 2) hash[lastk] = kov;
						else lastk = kov.replace(/^:/,'');
					});
					return hash;
				case 'list':
					return _.slice(1).map(function(v){
						return evaluate(v, global);
					})
				case 'if':
				case 'cond':
					var test = _[1],
						therefore = _[2],
						otherwise = _[3];
					var branch = evaluate(test, global) ?
						therefore : otherwise;
					return evaluate(branch, global);
				case 'set!':
					var value = evaluate(_[2], global);
					return env.eset(global, _[1], value);
				case 'define':
					var value = evaluate(_[2], global);
					return core.define(global, _[1], value);
				case 'lambda':
					return function(){
						return evaluate(_[2],
							env.mkenv(_[1], arguments, global));
					}
				case 'begin':
					var args = _.slice(1),
						result;
					for (var a in args)
						result = evaluate(args[a], global)
					return result;
				case 'eval':
					return evaluate(
						evaluate(_[1], global), 
					global);
				default:
					var proc = evaluate(_[0], global);
					if (proc.__macro){
						return evaluate(proc.apply(global, _.slice(1)), global); 
					}
					var exps = _.slice(1).map(function(exp){
						return evaluate(exp, global);
					});
					if (proc.__root){
						return proc.apply(proc.__root, exps);
					} return proc.apply && proc.apply(proc, exps);
			}
		}
/*	} catch(e) {
		var errors = {
			"Cannot read property 'values' of undefined": 'not found'
		};
		if (e.message in errors){
			e.message = errors[e.message];
		}
		return "\033[1;31m" + e.message + "\033[m";
	}*/
}

