var assert = require('assert'),
	tests = {
		basic: require('./test-basic').tests,
	};

var core = require('../lib/core');

global = {
	values: {
		'eq?': core.eqp,
		'equal?': core.equalp,
		'list?': core.arrayp,
		'hash?': core.hashp,
		'function?': core.functionp,
		'number?': core.numberp,
		'string?': core.stringp,
		'undefined?': core.undefinedp,
		'null?': core.nullp,
		'+': core.plus,
		'-': core.minus,
		'*': core.mult,
		'/': core.div,
		'=': core.eq,
		'>': core.gt,
		'>=': core.gte,
		'<': core.lt,
		'<=': core.lte,
		'get': core.get,
		'assoc': core.assoc,
		'keys': core.keys,
		'values': core.values,
		'nth': core.nth,
		'length': core.length,
		'cons': core.cons,
		'car': core.car,
		'cdr': core.cdr,
		'append': core.append,
		'mapf': core.map,
		'reducef': core.reduce
	}
}

var parse = require('../lib/parse').parse;

for (suite in tests){
	console.log('- running *'+suite+'* tests')
	for (var test=0;test<tests[suite].length;test++){
		var curr = tests[suite][test];
		try {
			var parsed = parse(curr[0],global);
		} catch(e) {
			console.log('\ntest '+(test+1)+' error. '+e.message);
		}
		var equal = true;
		if (parsed && parsed.push){
			if (assert.deepEqual(parsed,curr[1])){
				equal = false;
			}
		} else {
			if (curr[1].toString().indexOf('$') == 0){
				equal = (typeof parsed == curr[1].slice(1));
			} else if (parsed !== curr[1]){
				equal = false
			}
		} if (equal){
			process.stdout.write('.');
		} else {
			console.log('failed: ',curr[0]);
			console.log('expected: ',curr[1]);
			console.log('got: ',parsed);
		}
	} process.stdout.write("\n");
}
		
